;-------------------------------------------
;ƣLCD
;ڰ汾2021/1/19 <V1.0>
;ע
;* ΢뵼 &Ӧֲ֧& д
;*˾ַ www.mcu.com.cn
;*֧QQ 3001082102  ޹
;            3001030138	Ī
;-------------------------------------------

#INCLUDE	CMS79F136.H


COM0		EQU			PORTB,0			;ӦCOM
COM1		EQU			PORTB,1
COM2		EQU			PORTB,2
COM3		EQU			PORTB,3

SEGA		EQU			PORTA,5			;ӦSEG
SEGB		EQU			PORTA,4
SEGC		EQU			PORTA,3
SEGD		EQU			PORTA,2
SEGE		EQU			PORTA,1
SEGF		EQU			PORTA,0
SEGG		EQU			PORTA,6
SEGDP		EQU			PORTA,7

GPR0		EQU			?				;жϷбACC
GPR1		EQU			?				;жϷбSTATUS
TCOUNT		EQU			?				;жϴ

DISPDATA0	EQU			?				;COM0ʾ
DISPDATA1	EQU			?				;COM1ʾ
DISPDATA2	EQU			?				;COM2ʾ
DISPDATA3	EQU			?				;COM3ʾ
DISP_TEMP	EQU			?

DCOUNT		EQU			?				;ѭCOM

SMG_0		DEF			03FH			;0
SMG_1		DEF			006H			;1
SMG_2		DEF			05BH			;2
SMG_3		DEF			04FH			;3	
SMG_4		DEF			066H			;4
SMG_5		DEF			06DH			;5
SMG_6		DEF			07DH			;6
SMG_7		DEF			007H			;7
SMG_8		DEF			07EH			;8
SMG_9		DEF			06FH			;9
SMG_A		DEF			077H			;A
SMG_B		DEF			07CH			;B
SMG_C		DEF			039H			;C
SMG_D		DEF			05EH			;D
SMG_E		DEF			079H			;E
SMG_F		DEF			071H			;F

ORG			0000H						
JP			START						
ORG			0004H
JP			INT_SERVICE

;-------------------------------------------
START:
		LDIA		00H
		OPTION							;ԤƵTMR0
		CLR			TMR0				;ʼTMR0
		
		LDIA		071H				;16Mڲʱ
		LD			OSCCON,A
		
		CLR			TRISA				;ûҪSEG̬
		
		CLR			PIE1
		CLR			PIE2
		CLR			PIR1
		CLR			PIR2
		;TMR2 125usжϳʼ
		LDIA		.124				;16M125*1US=125US
		LD  		PR2,A				;
		LDIA		02H					;TMR2PR2ƥж
		LD			PIE1,A
		LDIA		B'00000101'			;1:1ƵȣʹTIMER2ԤƵֵΪ4
		LD  		T2CON,A
		LDIA		0C0H
		LD  		INTCON,A			;ȫжʹܣʱ2жʹ
		
MAIN:									;
		CLRWDT
		LDIA		.20					;20*125US = 2.5MSһ
		SUBA		TCOUNT
		SNZB		STATUS,C
		JP			MAIN
MIAN1		
		CLR			TCOUNT
		
		LDIA		SMG_0				;ʾ
		LD			DISPDATA0,A
		LDIA		SMG_1
		LD			DISPDATA1,A
		LDIA		SMG_2
		LD			DISPDATA2,A
		LDIA		SMG_3
		LD			DISPDATA3,A
		
		CALL		DISP_LCD			;ʾ
		
		JP			MAIN
;-------------------------------------------
;жϷ
INT_SERVICE:
        LD  		GPR0,A				;жֳ
		SWAPR		GPR0
		SWAPA		STATUS
		LD  		GPR1,A
INT_TMR2:
		CLRB 		PIR1,1				;TMR2жӦ־λ
		INCR		TCOUNT
INT_EXIT:
		SWAPA		GPR1
		LD  		STATUS,A
		SWAPA		GPR0
		RETI
;-------------------------------------------
;ƣDISP_LCD
;ܣʾִг
;ڲ
;ڲ
;		   
;	   ע
;-------------------------------------------
DISP_LCD:
		LDIA		B'11000000'			;LCD
		LD			LCDCON2,A
		
		LDIA		B'00001111'			;ȽӦCOMΪ̬
		LD			LCDCON1,A
		
		LDIA		B'10000000'			;ʹLCDģ
		LD			LCDCON,A
		
		SZB			DCOUNT,0			;Ƚʾر
		JP			HIGHV
		JP			LOWV
HIGHV:
		SETB		SEGA
		SETB		SEGB
		SETB		SEGC
		SETB		SEGD
		SETB		SEGE
		SETB		SEGF
		SETB		SEGG
		SETB		SEGDP
		JP			DISP
LOWV:
		CLRB		SEGA
		CLRB		SEGB
		CLRB		SEGC
		CLRB		SEGD
		CLRB		SEGE
		CLRB		SEGF
		CLRB		SEGG
		CLRB		SEGDP
		JP			DISP
DISP:
		LDIA		00H
		LD			PCLATH,A

		INCR		DCOUNT				;ѭCOM
		LDIA		07H
		ANDA		DCOUNT
		ADDR		PCL
		JP			DISP1_COM0
		JP			DISP2_COM0
		JP			DISP1_COM1
		JP			DISP2_COM1
		JP			DISP1_COM2
		JP			DISP2_COM2
		JP			DISP1_COM3
		JP			DISP2_COM3
		
DISP1_COM0:
		CLRB		COM0
		LDIA		B'00001110'
		LD			LCDCON1,A
		LDIA		B'00001110'
		LD			TRISB,A
		CLRB		COM0
		
		LD			A,DISPDATA0
		LD			DISP_TEMP,A
		CALL		SEG_ON1				;SEGӳ
		
		JP			DISP_LCD_BACK		
DISP2_COM0:
		SETB		COM0
		LDIA		B'00001110'
		LD			LCDCON1,A
		LDIA		B'00001110'
		LD			TRISB,A
		SETB		COM0
		
		LD			A,DISPDATA0
		LD			DISP_TEMP,A
		CALL		SEG_ON2				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP1_COM1:
		CLRB		COM1
		LDIA		B'00001101'
		LD			LCDCON1,A
		LDIA		B'00001101'
		LD			TRISB,A
		CLRB		COM1
		
		LD			A,DISPDATA1
		LD			DISP_TEMP,A
		CALL		SEG_ON1				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP2_COM1:
		SETB		COM1
		LDIA		B'00001101'
		LD			LCDCON1,A
		LDIA		B'00001101'
		LD			TRISB,A
		SETB		COM1
		
		LD			A,DISPDATA1
		LD			DISP_TEMP,A
		CALL		SEG_ON2				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP1_COM2
		CLRB		COM2
		LDIA		B'00001011'
		LD			LCDCON1,A
		LDIA		B'00001011'
		LD			TRISB,A
		CLRB		COM2
		
		LD			A,DISPDATA2
		LD			DISP_TEMP,A
		CALL		SEG_ON1				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP2_COM2
		SETB		COM2
		LDIA		B'00001011'
		LD			LCDCON1,A
		LDIA		B'00001011'
		LD			TRISB,A
		SETB		COM2
		
		LD			A,DISPDATA2
		LD			DISP_TEMP,A
		CALL		SEG_ON2				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP1_COM3
		CLRB		COM3
		LDIA		B'00000111'
		LD			LCDCON1,A
		LDIA		B'00000111'
		LD			TRISB,A
		CLRB		COM3
		
		LD			A,DISPDATA3
		LD			DISP_TEMP,A
		CALL		SEG_ON1				;SEGӳ
		
		JP			DISP_LCD_BACK
DISP2_COM3
		SETB		COM3
		LDIA		B'00000111'
		LD			LCDCON1,A
		LDIA		B'00000111'
		LD			TRISB,A
		SETB		COM3
		
		LD			A,DISPDATA3
		LD			DISP_TEMP,A
		CALL		SEG_ON2				;SEGӳ
		
		JP			DISP_LCD_BACK		
DISP_LCD_BACK:
		RET
;-------------------------------------------
;ӳ
SEG_ON1:			;ʾݣӦSEG
		SZB			DISP_TEMP,0
		SETB		SEGA
		SZB			DISP_TEMP,1
		SETB		SEGB
		SZB			DISP_TEMP,2
		SETB		SEGC
		SZB			DISP_TEMP,3
		SETB		SEGD
		SZB			DISP_TEMP,4
		SETB		SEGE
		SZB			DISP_TEMP,5
		SETB		SEGF
		SZB			DISP_TEMP,6
		SETB		SEGG
		SZB			DISP_TEMP,7
		SETB		SEGDP
		RET
SEG_ON2			;ʾݣӦSEG
		SZB			DISP_TEMP,0
		CLRB		SEGA
		SZB			DISP_TEMP,1
		CLRB		SEGB
		SZB			DISP_TEMP,2
		CLRB		SEGC
		SZB			DISP_TEMP,3
		CLRB		SEGD
		SZB			DISP_TEMP,4
		CLRB		SEGE
		SZB			DISP_TEMP,5
		CLRB		SEGF
		SZB			DISP_TEMP,6
		CLRB		SEGG
		SZB			DISP_TEMP,7
		CLRB		SEGDP
		RET